<template>
  <div class="mobile-container">
    <van-sticky class="containter-sticky">
      <navBar @clickLeft="onClickLeft" :leftText="title"></navBar>
    </van-sticky>
    <!-- <div class="group-title">基础信息</div> -->
    <div class="containter-content">
      <van-form :disabled="true" @submit="onSubmit">
        <div class="hidden-trouble">
          <div class="trouble-content">
            <div>
              <van-field
                readonly
                clickable
                name="datetimePicker"
                :value="detailListFrom.checkDate"
                label="隐患发现时间"
                placeholder="点击选择时间"
                @click="showPicker = true"
              />
              <van-popup v-model="showPicker" position="bottom">
                <van-datetime-picker
                  type="date"
                  @confirm="onConfirm"
                  @cancel="showPicker = false"
                />
              </van-popup>
              <van-field
                v-model="detailListFrom.dangerContent"
                name="隐患内容"
                label="隐患内容"
                placeholder="请输入隐患内容"
                :rules="[{required: true, message: '请填写隐患内容'}]"
              />
              <van-field
                v-model="detailListFrom.reformSugguest"
                name="整改措施建议"
                label="整改措施建议"
                placeholder="请输入整改措施建议"
              />
              <van-field
                v-model="detailListFrom.reference"
                name="参考依据说明"
                label="参考依据说明"
                placeholder="请输入参考依据说明"
              />
              <van-field name="uploader" label="隐患图片">
                <template #input>
                  <!-- <van-uploader v-model="item.uploader" /> -->
                  <el-upload
                    name="files"
                    :action="uploadUrl"
                    :headers="header"
                    accept="image/jpg, image/jpeg, image/png"
                    :data="{bizCode: 'Image', bizId: ''}"
                    :on-success="
                      (response, file, fileList) => {
                        return handleAvatarSuccess(response, file, fileList)
                      }
                    "
                    :before-upload="beforeAvatarUpload"
                    list-type="picture-card"
                    :on-remove="
                      (file, fileList) => {
                        return handleRemove(file, fileList)
                      }
                    "
                    :file-list="convertImg(detailListFrom.imgUrlArray)"
                  >
                    <i slot="default" class="el-icon-plus" />
                  </el-upload>
                </template>
              </van-field>
              <van-field name="uploader" label="整改后图片">
                <template #input>
                  <el-upload
                    name="files"
                    :action="uploadUrl"
                    :headers="header"
                    accept="image/jpg, image/jpeg, image/png"
                    :data="{bizCode: 'Image', bizId: ''}"
                    :on-success="
                      (response, file, fileList) => {
                        return handleAvatarSuccess1(response, file, fileList)
                      }
                    "
                    :before-upload="beforeAvatarUpload"
                    list-type="picture-card"
                    :on-remove="
                      (file, fileList) => {
                        return handleRemove1(file, fileList)
                      }
                    "
                    :file-list="convertImg(detailListFrom.reformImgUrlArray)"
                  >
                    <i slot="default" class="el-icon-plus" />
                  </el-upload>
                </template>
              </van-field>
            </div>
            <div class="confirm-button" style="margin: 16px;">
              <van-button
                round
                block
                type="info"
                native-type="submit"
                @click="confirmBtn"
              >保存
              </van-button
              >
            </div>
          </div>
        </div>
      </van-form>
    </div>
  </div>
</template>

<script>
import moment from 'moment'
import CmgtSaftyDangerCheckrecordApi from '@/views/Manage/saftyDanger/api/CmgtSaftyDangerCheckrecordApi'
import dictUtils from '@/components/dict/DictSelectUtils.js'
import equipmentManage from '@/api/device/equipmentManage.js'
import navBar from '../components/navBar.vue'
import {mapState} from 'vuex'

export default {
  name: 'DeviceDetail',
  components: {
    navBar
  },
  data() {
    return {
      popupShow: false,
      detailListFrom: {
        checkRecordId: null,
        unitId: null,
        reformImgUrlArray: [],
        imgUrlArray: [],
        checkDate: null,
        dangerContent: null,
        reformSugguest: null,
        reference: null,
        id: null
      },
      params: {
        unitId: '',
        id: '',
        detail: []
      },
      showPicker: false,
      value: '',
      showCalendar: false,
      showPicker: false,
      uploader: [{url: 'https://img01.yzcdn.cn/vant/leaf.jpg'}],
      uploadUrl: window.context.portal + '/file/v1/uploadFileForConfig', // 服务器上传地址
      previewUrl:
        window.context.portal + '/file/onlinePreviewController/v1/getFileById_',
      title: '隐患内容',
      columns: ['九小场所', '重点单位'],
      deviceData: {},
      paramsValueList: [],
      extendParams: [],
      loading: false
    }
  },
  computed: mapState({
    header: state => {
      return {
        Authorization: `Bearer ${state.login.currentUser.token}`
      }
    }
  }),
  mounted() {
    this.deviceStatus = dictUtils.getDictItemsFromCache('sbzt')
    this.deviceAzlc = dictUtils.getDictItemsFromCache('azlc')
    this.deviceAzddlx = dictUtils.getDictItemsFromCache('azddlx')
    this.device = this.$route.query.item
    this.dblclickDetail(this.device)
  },
  methods: {
    //删除隐患
    delTrouble(index, row) {
      // this.params.detail.splice(index, 1)
      // console.log(row)
      CmgtSaftyDangerCheckrecordApi.CSaftyDangerCheckrecordDetailDelete(
        [row.id],
        res => {
          this.$toast.success('删除成功')
          this.Update(this.params.id)
        }
      )
    },
    //返回
    popupShowBack() {
      this.handelCloseDetail()
    },
    //清空
    handelCloseDetail() {
      this.detailListFrom = {
        checkRecordId: null,
        unitId: null,
        imgUrlArray: [],
        reformImgUrlArray: [],
        checkDate: null,
        dangerContent: null,
        reformSugguest: null,
        reference: null,
        id: null
      }
      this.popupShow = false
    },
    //确认
    confirmBtn() {
      console.log(this.detailListFrom)
      CmgtSaftyDangerCheckrecordApi.CSaftyDangerCheckrecordDetailUpdateById(
        this.detailListFrom,
        res => {
          console.log(res)
          // this.$notify({
          //   type: 'success',
          //   message: '修改成功',
          //   duration: 2000
          // })
          this.$toast.success('修改成功')
          this.handelCloseDetail()
          this.Update(this.params.id)
        }
      )
    },
    //
    dblclickDetail(row) {
      console.log(row)
      this.detailListFrom.checkRecordId = row.checkRecordId
      this.detailListFrom.unitId = row.unitId
      this.detailListFrom.imgUrlArray = row.imgUrlArray ? row.imgUrlArray : []
      this.detailListFrom.reformImgUrlArray = row.reformImgUrlArray
        ? row.reformImgUrlArray
        : []
      this.detailListFrom.checkDate = row.checkDate
      this.detailListFrom.dangerContent = row.dangerContent
      this.detailListFrom.reformSugguest = row.reformSugguest
      this.detailListFrom.reference = row.reference
      this.detailListFrom.id = row.id
      this.detailListFrom.fileList = row.fileList
    },
    // 图片转换
    convertImg(arr) {
      let newArr = []
      if (Array.isArray(arr)) {
        newArr = arr.map(it => {
          return {url: this.previewUrl + it, id: it}
        })
        return newArr
      }
      console.log(newArr)
    },
    beforeAvatarUpload(file) {
      const isJPG =
        file.type === 'image/jpeg' ||
        file.type === 'image/png' ||
        file.type === 'image/jpg'
      const isLt10M = file.size / 1024 / 1024 < 10
      if (!isJPG) {
        this.$message.error('上传图片只能是 JPG 格式!')
      }
      if (!isLt10M) {
        this.$message.error('上传图片大小不能超过 10MB!')
      }
      return isJPG && isLt10M
    },
    handleAvatarSuccess(res, file, fileList) {
      if (res.success) {
        let arr = []
        arr.push(res.fileId)
        this.detailListFrom.imgUrlArray = this.detailListFrom.imgUrlArray.concat(
          arr
        )
      } else {
        this.$message.error('上传文件失败！')
      }
    },
    handleAvatarSuccess1(res, file, fileList) {
      if (res.success) {
        let arr = []
        arr.push(res.fileId)
        this.detailListFrom.reformImgUrlArray = this.detailListFrom.reformImgUrlArray.concat(
          arr
        )
      } else {
        this.$message.error('上传文件失败！')
      }
    },
    handleRemove(file, fileList) {
      this.detailListFrom.imgUrlArray.forEach((e, index) => {
        if (e == file.id) {
          this.detailListFrom.imgUrlArray.splice(index, 1)
        }
      })
    },
    handleRemove1(file, fileList) {
      this.detailListFrom.reformImgUrlArray.forEach((e, index) => {
        if (e == file.id) {
          this.detailListFrom.reformImgUrlArray.splice(index, 1)
        }
      })
    },
    //
    onConfirm(date) {
      this.detailListFrom.checkDate = moment(date).format('YYYY-MM-DD')
      this.showPicker = false
    },
    onSubmit(values) {
      console.log('submit', values)
    },
    onClickLeft() {
      this.$router.push({name: 'MobileSaftyDanger'})
    }
  }
}
</script>

<style lang="scss" scoped>
@import '@/assets/css/element-variables.scss';

.mobile-container {
  width: 95%;
  min-height: 100%;
  // background-color: $--mobile-bg;
  background-color: #f4f7ff;
  overflow-y: scroll;
  padding: 20px 50px;

  .containter-sticky {
    position: fixed;
    top: 0;
    width: 100%;
    z-index: 200;
  }
}

.form-btn {
  display: flex;
  justify-content: flex-end;
}

.popup-content {
  height: 86%;
  overflow-y: scroll;
}

::v-deep .el-upload--picture-card {
  width: 350px !important;
  height: 350px !important;
  line-height: 350px !important;
}

.trouble-top {
  display: flex;
  justify-content: space-between;
  align-items: center;
}

::v-deep .el-upload-list--picture-card .el-upload-list__item {
  width: 350px !important;
  height: 350px !important;
}

.hidden-trouble {
  background-color: white;

  .trouble-Btn {
    display: flex;
    justify-content: flex-end;
    padding: 20px 20px 0 0;
  }

  // .trouble-content {
  //   display: flex;
  //   justify-content: space-between;
  //   align-items: center;
  // }
  .trouble-title {
    // font-weight: bold;
    font-size: 80px;
    margin-top: 20px;
    margin-left: 80px;
  }
}

.device-content {
  // padding: 50px 0px 50px 0px;
  height: 400px;
  font-size: 50px;

  p {
    color: #929494;
    margin: 10px 0 10px 0;
  }
}

.device-group {
  padding: 0 60px 0 60px;
  margin-top: 16px !important;
}

.group-title {
  padding: 20px 16px 10px 16px;
  color: #888888;
  font-size: 78px;
}

.title-bar {
  display: inline-block;
  width: 4px;
  height: 12px;
  background-color: #1989fa;
  margin-right: 4px;
  vertical-align: middle;
}

.device-cell {
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding: 40px 0 40px 0;
  border-bottom: 1px solid #dedddd;
}

.device-name {
  font-size: 88px;
  color: $--mobile-text-main;
}

.cell-title {
  color: $--mobile-text-sub;
  font-size: 82px;
  margin-right: 10px;
}

.cell-value {
  color: $--mobile-text-main;
  font-size: 82px;
}

.margin-bottom {
  margin-bottom: 16px !important;
}

.device-status .van-tag {
  padding: 10px 40px 10px 40px;
  font-size: 72px;
}

.van-cell-group--inset {
  margin: 0 0;
  border-radius: 0;
}

.van-cell {
  justify-content: start;
}

.van-cell__title,
.van-cell__value {
  width: auto;
  flex: initial;
}

.van-cell__title {
  white-space: nowrap;
}

.van-cell__value {
  padding-left: 10px;
  text-align: left;
}

.van-cell__title span,
.van-cell__value span {
  font-size: 76px;
  color: $--mobile-text-main;
}

.van-cell__title span {
  color: $--mobile-text-sub;
}
</style>
<style lang="scss">
@import '@/assets/css/vant-custom.scss';
</style>
